#| Scratch file for module system scribblings

<system description> ---> <component definition>*

<component definition> --->
   <interface definition>
 | <locale definition>
 | <implementation definition>

<interface definition> --->
   (DEFINE-INTERFACE <interface name> <interface>)

<interface name> ---> <component name>

<interface> --->
   <simple interface>
 | <interface union>
 | <modified interface>
 | <interface name>

<simple interface> ---> (EXPORT <export specifier>*)

<export specifier> ---> <identifier> | (<identifier class> <identifier>*)

<identifier class> ---> VARIABLE | SYNTAX

<interface union> ---> (UNION <interface>*)

<modified interface> ---> (MODIFY <interface> <modifier command>)

<modifier command> ---> <renaming command> | <restricting command>

<renaming command> --->
   (RENAME (<from-identifier> <to-identifier>)*)
 | (ALIAS (<from-identifier> <to-identifier>)*)
 | (PREFIX <prefix>)

<restricting command> --->
   (EXCEPT <identifier>*)
 | (ONLY <identifier>*)

<locale definition> --->
   (DEFINE-LOCALE <locale name>
       (<implementation specification>*)
     <locale clause>*)

<locale name> ---> <component name>

<implementation specification> --->
   (IMPLEMENT <component name> <implementation clause>*)
 | (IMPLEMENT-AS <implementation name> <interface>
     <implementation clause>*)

<locale clause> --->
   (IMPORT <implementation>*)
 | (FILES <file specifier>*)
 | (DECLARE <declaration>*)
 | (INITIALIZATION <initialization>*)
 | (FINALIZATION <finalization>*)
 | (META <locale clause>*)

<implementation definition> --->
   (DEFINE-IMPLEMENTATION <component name>
       (<implementation clause>*)
     <locale clause>*)
 | (DEFINE-IMPLEMENTATION-AS <implementation name> <interface>
       (<implementation clause>*)
     <locale clause>*)

<implementation clause> --->
   (TRANSLATE <renaming command>*)
 | (DOCUMENTATION ...)

|#

(define-interface factorial-interface
  (export factorial))

(define-implementation factorial factorial-interface
    ((translate (rename (fact factorial))))
  (import (from (scheme) r5rs))
  (code
    (define (fact n)
      (do ((c 1 (+ c 1))
           (p 1 (* p c)))
          ((> c n) p)))
    ))
